clear
clc
clear all 

rng('default');

Zeta=0.01;

Links=MinimumDistance(40,80);
Lambdamu=rand(40,1)*300-100;
while sum(Lambdamu)<0
    Lambdamu=rand(40,1)*250-50;
end

ii=0;
%Change increment
for i=0:2:200
     ii=ii+1;
     Lambdasig=ones(1,40)*(i/40);
     [Satisfied, Edges]=QuenchedWithZeta(Lambdamu,Lambdasig,Links,Zeta);
     CostAll(ii)=sum(Edges(:,3).^2);
     jj=0;
     %Change Number for mean
     for j=1:10
         jj=jj+1;
         a=randi(40);
         Lambdasig=zeros(1,40);
         Lambdasig(a)=i;
         [Satisfied, Edges]=QuenchedWithZeta(Lambdamu,Lambdasig,Links,Zeta);
         CostOne(ii,jj)=sum(Edges(:,3).^2);
         a=randi(40,1,20);
         Lambdasig=zeros(1,40);
         for k=1:20
             Lambdasig(a(k))=i/20;
         end
         [Satisfied, Edges]=QuenchedWithZeta(Lambdamu,Lambdasig,Links,Zeta);
         CostSome(ii,jj)=sum(Edges(:,3).^2);
         a=randi(40,1,30);
         Lambdasig=zeros(1,40);
         for k=1:30
             Lambdasig(a(k))=i/30;
         end
         [Satisfied, Edges]=QuenchedWithZeta(Lambdamu,Lambdasig,Links,Zeta);
         CostMany(ii,jj)=sum(Edges(:,3).^2);
         a=randi(40,1,10);
         Lambdasig=zeros(1,40);
         for k=1:10
             Lambdasig(a(k))=i/10;
         end
         [Satisfied, Edges]=QuenchedWithZeta(Lambdamu,Lambdasig,Links,Zeta);
         CostFew(ii,jj)=sum(Edges(:,3).^2);
         Sigma(ii)=i;
     end
     
     
end         

CostOne=CostOne';
CostFew=CostFew';
CostSome=CostSome';
CostMany=CostMany';
CostAll=CostAll';
     

figure('Units','centimeters','Position',[5 5 16 13],'PaperPositionMode','auto')

p=plot(Sigma,CostAll,'bo',Sigma,mean(CostMany),'r+',Sigma,mean(CostSome),'k*',Sigma,mean(CostFew),'g.',Sigma,mean(CostOne),'mx');

xlabel('Overall sum of $\sigma$''s');
ylabel('Transportation Cost');
title('Transportation Cost over Total Sigma');
axis([0 Sigma(end) 20000 140000]);
set(p(1),'Color',[0 1 0],'Marker','*','MarkerSize',5,'LineStyle','none');
set(p(2),'Color',[0 1 1],'Marker','*','MarkerSize',5,'LineStyle','none');
set(p(3),'Color',[0 0 1],'Marker','*','MarkerSize',5,'LineStyle','none');
set(p(4),'Color',[1 0 1],'Marker','*','MarkerSize',5,'LineStyle','none');
set(p(5),'Color',[1 0 0],'Marker','*','MarkerSize',5,'LineStyle','none');
set(gca,'YLim',[20000 140000],'YColor',[0 0 0],'XLim',[0 Sigma(end)]);
set(gca,...
'Units','normalized',...
'YTick',20000:10000:140000,...
'XTick',0:50:200,...
'Position',[.17 .15 .7 .7],...
'FontUnits','points',...
'FontWeight','normal',...
'FontSize',18,...
'FontName','Times',...
'TickDir','out')
ylabel('Transportation Cost',...
'FontUnits','points',...
'interpreter','latex',...
'FontSize',20,...
'Color','k',...
'FontName','Times',...
'Position',[-20 80000 0])
xlabel('Overall sum of $\sigma$''s',...
'FontUnits','points',...
'interpreter','latex',...
'FontWeight','normal',...
'FontSize',20,...
'FontName','Times',...
'Position',[100 8000 0])
title('Transportation Cost over Total $\sigma$',...
'FontUnits','points',...
'FontWeight','normal',...
'interpreter','latex',...
'FontSize',20,...
'FontName','Times',...
'Position',[100 152000 0],...
'fontweight','bold');
legend('100%','75%','50%','25%','2.5%');
print -dpng SigmaOverCostForManySigmas.png


